-- vim: ts=2 sw=2 ai et enc=utf8 fenc=utf8

local RC = RaidChecklist
local P = RaidChecklistPetFamilies

RC.petproviders = { }
for i,b in ipairs (RC.buffs) do RC.petproviders[b] = {} end
for i,b in ipairs (RC.debuffs) do RC.petproviders[b] = {} end

local matrix = {
  [P.BAT]         = { },
  [P.BEAR]        = { "DEMOROAR" },
  [P.BEETLE]      = { },
  [P.BIRDOFPREY]  = { },
  [P.BOAR]        = { "BLEEDDMGTAKEN" },
  [P.CARRIONBIRD] = { },
  [P.CAT]         = { "AGISTR" },
  [P.CHIMAERA]    = { },
  [P.COREHOUND]   = { "BLOODLUST", "CASTSPD" },
  [P.CRAB]        = { },
  [P.CROCOLISK]   = { },
  [P.DEVILSAUR]   = { "CRIT", "MORTALSTRIKE" },
  [P.DOG]         = { },
  [P.DOOMGUARD]   = { },
  [P.DRAGONHAWK]  = { "SPELLDMGTAKEN" },
  [P.FELGUARD]    = { },
  [P.FELHUNTER]   = { "MANA", "MANAREGEN" },
  [P.FOX]         = { "ATTACKSPD" },
  [P.GHOUL]       = { },
  [P.GORILLA]     = { },
  [P.HYENA]       = { "BLEEDDMGTAKEN" },
  [P.IMP]         = { },
  [P.MONKEY]      = { },
  [P.MOTH]        = { },
  [P.NETHERRAY]   = { },
  [P.RAPTOR]      = { "SUNDER" },
  [P.RAVAGER]     = { "PHYSDMGTAKEN" },
  [P.RHINO]       = { "BLEEDDMGTAKEN" },
  [P.SCORPID]     = { },
  [P.SERPENT]     = { "SUNDER" },
  [P.SHALESPIDER] = { "STATS" },
  [P.SILITHID]    = { "STAM" },
  [P.SPIDER]      = { },
  [P.SPIRITBEAST] = { "AGISTR" },
  [P.SPOREBAT]    = { "CASTSPD" },
  [P.SUCCUBUS]    = { },
  [P.TALLSTRIDER] = { "ATTACKSPD" },
  [P.TURTLE]      = { },
  [P.VOIDWALKER]  = { },
  [P.WARPSTALKER] = { },
  [P.WASP]        = { },
  [P.WINDSERPENT] = { "SPELLDMGTAKEN" },
  [P.WOLF]        = { "CRIT" },
  [P.WORM]        = { "PHYSDMGTAKEN" },
} 


local function remove_petprovider (rguid)
  for key,guidlist in pairs (RC.petproviders) do
    guidlist[rguid] = nil
  end
  if (RC.OnRefresh) then RC:OnRefresh () end
end


local function add_petprovider (buff, guid)
  RC.petproviders[buff][guid] = true
  if (RC.OnRefresh) then RC:OnRefresh () end
end


local RCB = RaidChecklistButton
RCB:SetScript ("OnEvent", function (self, event, ...) if self[event] then self[event] (self, ...) end end)

function RCB:UNIT_PET (unit)
  local guid = UnitGUID (unit)
  if not guid then return end
  remove_petprovider (guid)
  local family = UnitCreatureFamily (unit.."pet")
  if not family then return end
  local list = matrix[family]
  if not list then
    -- I encounter a crash here once in WG - need to find out what caused it!
    DEFAULT_CHAT_FRAME:AddMessage("RCdebug: missing family '"..(family or "nil").."'")
    return
  end
  for i,key in ipairs (list) do
    add_petprovider (key, guid)
  end
end

RCB:RegisterEvent("UNIT_PET")

